<template>
  <!-- Layout container -->
  <div id="_layout">
    <!-- Header -->
    <div
      :class="[
        'max-w-screen-2xl',
        'm-auto'
      ]"
    >
      <LayoutHeader />
    </div>

    <div
      :class="[
        'flex',
        'max-w-screen-2xl',
        'm-auto'
      ]"
    >
      <!-- Side bar -->
      <SideBar v-if="showSidebar" />

      <!-- Page content -->
      <div class="w-full">
        <!-- Breadcrumb -->
        <div class="mx-3 mt-1 mb-3">
          <Breadcrumb :items="breadcrumbs" />
        </div>
        <!-- Default slot -->
        <div class="mx-3">
          <slot name="default" />
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { Core, toolbox } from '@hperchec/scorpion-ui'

const Route = Core.context.services.router.Route
const { mapComponent } = toolbox.template.utils

/**
 * Defines the event listener
 */
const routerViewListener = function ({ ref }) {
  // this is the Vue instance
  this.updateBreadcrumbs(ref)
}

/**
 * Public layout
 */
export default {
  components: {
    Breadcrumb: mapComponent('vue.components.shared.Breadcrumb'),
    LayoutHeader: mapComponent('vue.components.layouts.public.partials.header.LayoutHeader'),
    SideBar: mapComponent('vue.components.layouts.public.partials.side-bar.SideBar')
  },
  props: {
    /**
     * Show / hide the sidebar
     */
    showSidebar: {
      type: Boolean,
      default () {
        return true
      }
    }
  },
  data () {
    return {
      breadcrumbs: []
    }
  },
  created () {
    this.$app.on('Router/ROUTER_VIEW_UPDATED', routerViewListener.bind(this))
  },
  beforeDestroy () {
    this.$app.off('Router/ROUTER_VIEW_UPDATED', routerViewListener)
  },
  methods: {
    updateBreadcrumbs (routeComponentInstance) {
      this.breadcrumbs = Route.getBreadcrumb(this.$route, routeComponentInstance)
    }
  }
}
</script>
